<?php

namespace App\Http\Controllers\V3\Dashboard;

use App\Exports\V3\RoadPatrols\OperatorCartableReport;
use App\Exports\V3\RoadPatrols\SupervisorCartableReport;
use App\Facades\Sms\Sms;
use App\Http\Controllers\Controller;
use App\Http\Requests\V3\RoadPatrolProject\DeleteRequest;
use App\Http\Requests\V3\RoadPatrolProject\StoreRequest;
use App\Http\Traits\ApiResponse;
use App\Models\EdarateShahri;
use App\Models\InfoItem;
use App\Models\RoadItemsProject;
use App\Models\RoadObserved;
use App\Models\RoadPatrol;
use App\Services\NominatimService;
use App\Services\Cartables\RoadPatrolTableService;
use Carbon\Carbon;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Gate;
use Illuminate\Support\Facades\Storage;
use Illuminate\Validation\ValidationException;
use Maatwebsite\Excel\Facades\Excel;
use Symfony\Component\HttpFoundation\BinaryFileResponse;

class RoadPatrolProjectController extends Controller
{
    use ApiResponse;

    public function supervisorIndex(Request $request, RoadPatrolTableService $roadPatrolTableService): JsonResponse
    {
        $data = $roadPatrolTableService->supervisorCartableReport($request);

        foreach ($data['data'] as $road_patrol) {
            if (Gate::allows('gate-supervise-road-item', $road_patrol)) {
                $road_patrol['can_supervise'] = 1;
            } else {
                $road_patrol['can_supervise'] = 0;
            }
        }

        return response()->json($data);
    }

    public function delete(DeleteRequest $request, RoadPatrol $roadPatrol): JsonResponse
    {
        if ($request->type == 1) {
            DB::transaction(function () use ($roadPatrol) {
                $roadPatrol->observedItems()->delete();
                $roadPatrol->delete();
            });
        } else {
            DB::transaction(function () use ($roadPatrol) {
                if ($roadPatrol->observedItems) {
                    foreach ($roadPatrol->observedItems as $index => $observed_item) {
                        if ($observed_item->roadItemProject) {
                            $road_item = $observed_item->roadItemProject;

                            if ($road_item->files()->exists()) {
                                Storage::delete('public/'. $road_item->files[0]->path);
                                Storage::delete('public/'. $road_item->files[1]->path);
                                $road_item->files()->delete();
                            }

                            $road_item->delete();
                        }

                        $observed_item->delete();
                    }
                }
                auth()->user()->addActivityComplete(1144);

                $roadPatrol->delete();
            });
        }

        return $this->successResponse();
    }

    public function supervisorCartableReport(Request $request, RoadPatrolTableService $roadPatrolTableService): BinaryFileResponse
    {
        $name = 'گزارش از کارتابل ارزیابی گشت راهداری ' . verta()->now()->format('Y-m-d H:i') . '.xlsx';
        $data = $roadPatrolTableService->supervisorCartableReport($request, true);
        return Excel::download(new SupervisorCartableReport($data['data']), $name);
    }

    public function operatorIndex(Request $request, RoadPatrolTableService $roadPatrolTableService): JsonResponse
    {
        $data = $roadPatrolTableService->operatorCartableReport($request);
        return response()->json($data);
    }

    public function store(StoreRequest $request, NominatimService $nominatimService): JsonResponse
    {
        $user = auth()->user();

        if ($user->edarate_ostani_id || is_null($user->city_id)) {
            return $this->errorResponse('امکان ثبت فعالیت برای ادارات استانی وجود ندارد!');
        }

        if (is_null($user->edarate_shahri_id)) {
            return $this->errorResponse('اداره شهری برای شما در سامانه ثبت نشده است!');
        }

        $edare_id = $user->edarate_shahri_id ?? $user->edarate_ostani_id;
        $edare_name = $user->edarate_shahri_id ? $user->edarate_shahri_name : $user->edarate_ostani_name;

        $road_patrol = DB::transaction(function () use ($request, $edare_id,
            $edare_name, $nominatimService, $user) {

            $road_patrol = RoadPatrol::query()->create([
                'operator_id' => $user->id,
                'operator_name' => $user->name,
                'province_id' => $user->province_id,
                'province_fa' => $user->province_fa,
                'city_id' => $user->city_id,
                'city_fa' => $user->city_fa,
                'edare_id' => $edare_id,
                'edare_name' => $edare_name,
                'status' => 0,
                'status_fa' => 'در حال بررسی',
                'distance' => $request->distance,
                'start_time' => $request->start_time,
                'end_time' => $request->end_time,
                'description' => $request->description ?? null,
                'fuel_consumption' => $request->fuel_consumption,
                'vehicle_runtime' => $request->vehicle_runtime,
                'stop_points' => json_encode($request->stop_points),
            ]);

            $road_patrol->rahdaran()->attach($request->road_patrol_rahdaran_id);
            $road_patrol->cmmsMachines()->attach($request->road_patrol_machines_id);

            if ($request->observed_items) {
                foreach ($request->observed_items as $index => $item) {
                    $info_item = InfoItem::where('item', $item['item_id'])
                        ->where('sub_item', $item['sub_item_id'])
                        ->firstOrFail();

                    $item_start_coordinates = explode(',', $item['start_point']);

                    $observed_item = $road_patrol->observedItems()->create([
                        'item_id' => $info_item->item,
                        'item_name' => $info_item->item_str,
                        'sub_item_id' => $info_item->sub_item,
                        'sub_item_name' => $info_item->sub_item_str,
                        'local_name' => $item['local_name'],
                        'description' => $item['description'] ?? null,
                        'start_lat' => $item_start_coordinates[0],
                        'start_lon' => $item_start_coordinates[1],
                    ]);

                    $item_end_coordinates = null;
                    if ($item['instant_action'] == 0) {
                        $priority = [
                            1 => 'عادی',
                            2 => 'فوری',
                            3 => 'آنی',
                        ];
                        $observed_item->priority = $item['priority'];
                        $observed_item->priority_fa = $priority[$item['priority']];
                        $observed_item->save();
                    } elseif ($item['instant_action'] == 1) {
                        if ($info_item->needs_end_point) {
                            if (!isset($item['end_point'])) {
                                throw ValidationException::withMessages([
                                    "observed_items.$index.end_point" => __('validation.required', ['attribute' => 'end_point']),
                                ]);
                            }

                            $item_end_coordinates = explode(',', $item['end_point']);
                        }

                        $before_image = null;
                        $after_image = null;
                        if ($info_item->needs_image) {
                            if (!isset($item['before_image'])) {
                                throw ValidationException::withMessages([
                                    "observed_items.$index.before_image" => __('validation.required', ['attribute' => 'before_image']),
                                ]);
                            }
                            if (!isset($item['after_image'])) {
                                throw ValidationException::withMessages([
                                    "observed_items.$index.after_image" => __('validation.required', ['attribute' => 'after_image']),
                                ]);
                            }

                            $before_image = $item['before_image'];
                            $after_image = $item['after_image'];
                        }

                        $start_time = Carbon::createFromFormat('Y-m-d H:i', $request->start_time);
                        $end_time = Carbon::createFromFormat('Y-m-d H:i', $request->end_time);
                        $activity_date = $start_time->average($end_time);

                        $attributes = [
                            'start_lat' => $item_start_coordinates[0],
                            'start_lng' => $item_start_coordinates[1],
                            'end_lat' => $item_end_coordinates ? $item_end_coordinates[0] : null,
                            'end_lng' => $item_end_coordinates ? $item_end_coordinates[1] : null,
                            'item' => $info_item->item,
                            'item_fa' => $info_item->item_str,
                            'sub_item' => $info_item->sub_item,
                            'sub_item_fa' => $info_item->sub_item_str,
                            'sub_item_data' => $item['amount'],
                            'province_id' => $user->province_id,
                            'province_fa' => $user->province_fa,
                            'city_id' => $user->city_id,
                            'city_fa' => $user->city_fa,
                            'user_name' => $user->name,
                            'start_way_id' => $nominatimService->get_way_id_from_nominatim($item_start_coordinates[0], $item_start_coordinates[1]),
                            'end_way_id' => $item_end_coordinates ? $nominatimService->get_way_id_from_nominatim($item_end_coordinates[0], $item_end_coordinates[1]) : null,
                            'unit_fa' => $info_item->sub_item_unit,
                            'created_at_fa' => verta(Carbon::now())->format('Y-m-d H:i:s'),
                            'info_id' => $info_item->id,
                            'status' => 0,
                            'status_fa' => 'در حال بررسی',
                            'edarat_id' => $user->edarate_shahri_id,
                            'edarat_type' => EdarateShahri::class,
                            'edarat_name' => $user->edarate_shahri_name,
                            'activity_date' => $activity_date->format('Y-m-d'),
                            'activity_time' => $activity_date->format('H:i:s'),
                        ];

                        $road_item = RoadItemsProject::store($user, $attributes, $before_image, $after_image, $observed_item->id);

                        if ($road_item === -1) {
                            return $this->errorResponse('اقدام مربوطه قبلا رسیدگی شده است.');
                        }

                        $road_item->rahdaran()->attach($item['road_item_rahdaran_id']);
                        $road_item->cmmsMachines()->attach($item['road_item_machines_id']);
                    }
                }
            }

            auth()->user()->addActivityComplete(1147);

            Sms::sendSms($request->officer_phone_number,
                "گشت راهداری با کد یکتای $road_patrol->id در تاریخ ".verta(\Carbon\Carbon::now())->format('Y-m-d H:i:s')." با شماره شما در سامانه RMS ثبت شد. \n لینک دریافت گزارش : \n https://rms.rmto.ir/v2/road_patrols/operator/report/$road_patrol->id"
            );
            return $road_patrol;
        });

        return $this->successResponse();
    }

    public function getReport(RoadPatrol $roadPatrol): JsonResponse
    {
        $data = [
            'serial_no' => $roadPatrol->id,
            'province_fa' => $roadPatrol->province_fa,
            'edare_name' => $roadPatrol->edare_name,
            'start_time' => $roadPatrol->start_time,
            'end_time' => $roadPatrol->end_time,
            'officer_name' => $roadPatrol->officer_name,
            'officer_plaque' => $roadPatrol->officer_plaque,
            'officer_phone_number' => $roadPatrol->officer_phone_number,
            'created_at' => $roadPatrol->created_at
        ];

        $observed_items = array();
        if($roadPatrol->observedItems) {
            foreach ($roadPatrol->observedItems as $index => $observed_item) {
                $observed_items[] = [
                    'item' => $observed_item->item_name,
                    'sub_item' => $observed_item->sub_item_name,
                    'local_name' => $observed_item->local_name,
                    'description' => $observed_item->description,
                    'priority_fa' => $observed_item->priority_fa,
                ];
            }
        }

        $data['observed_items'] = $observed_items;
        return $this->successResponse($data);
    }

    public function map(Request  $request): JsonResponse
    {
        $province = $request->province_id;
        $edare_shahri = $request->edare_shahri_id;
        $status = $request->status;
        $rms_status = $request->rms_status;

        if ($request->from_date && $request->date_to) {
            $date_from = $request->from_date.' 00:00:00';
            $date_to = $request->date_to.' 23:59:59';
        } else {
            $date_from = Date('Y-m-d');
            $date_to = new \DateTime('tomorrow');
            $date_to = $date_to->format('Y-m-d');
        }

        $projects = RoadObserved::query()->select(['id', 'lng', 'lat','status'])
            ->whereBetween('created_at', [$date_from, $date_to])
            ->when($province, function ($query) use ($province) {
                return $query->where('province_id', '=', $province);
            })
            ->when($rms_status, function ($query) use ($rms_status) {
                if ($rms_status == 2) {
                    return $query->where('rms_status', '<>', 0);
                } else {
                    return $query->where('rms_status', '=', 0);
                }
            })
            ->when($edare_shahri, function ($query) use ($edare_shahri) {
                return $query->where('edarate_shahri_id', '=', $edare_shahri);
            })
            ->when($status, function ($query) use ($status) {
                return $query->where('status', '=', $status);
            })
            ->get();
        return $this->successResponse($projects);
    }

    public function show(RoadPatrol $roadPatrol): JsonResponse
    {
        return $this->successResponse($roadPatrol);
    }

    public function operatorCartableReport(Request $request, RoadPatrolTableService $roadPatrolTableService): BinaryFileResponse
    {
        $name = 'گزارش از کارتابل عملیات گشت راهداری ' . verta()->now()->format('Y-m-d H:i') . '.xlsx';
        $data = $roadPatrolTableService->operatorCartableReport($request, true);
        return Excel::download(new OperatorCartableReport($data['data']), $name);
    }

    public function roadPatrolMachine(RoadPatrol $roadPatrol): JsonResponse
    {
        return $this->successResponse($roadPatrol->cmmsMachines()->get(['cmms_machines.id', 'cmms_machines.machine_code', 'cmms_machines.car_name', 'cmms_machines.plak_number']));
    }

    public function roadPatrolRahdar(RoadPatrol $roadPatrol): JsonResponse
    {
        return $this->successResponse($roadPatrol->rahdaran()->get(['rahdaran.id', 'rahdaran.name', 'rahdaran.code']));
    }
}
